"use strict";

var _interopRequireWildcard = require("@babel/runtime-corejs2/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime-corejs2/helpers/interopRequireDefault");

var _Object$defineProperty = require("@babel/runtime-corejs2/core-js/object/define-property");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.default = void 0;

var _now = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/date/now"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/inherits"));

var _react = _interopRequireWildcard(require("react"));

var _reactTransformHmr3 = _interopRequireDefault(require("react-transform-hmr"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _moment = _interopRequireDefault(require("moment"));

var _components = {
  Timer: {
    displayName: "Timer"
  }
};

var _reactTransformHmr2 = (0, _reactTransformHmr3.default)({
  filename: "packages/node_modules/@ciscospark/react-component-timer/src/index.js",
  components: _components,
  locals: [module],
  imports: [_react.default]
});

function _wrapComponent(id) {
  return function (Component) {
    return _reactTransformHmr2(Component, id);
  };
}

var propTypes = {
  startTime: _propTypes.default.number.isRequired
};

var Timer =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2.default)(Timer, _Component);

  function Timer() {
    (0, _classCallCheck2.default)(this, Timer);
    return (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(Timer).apply(this, arguments));
  }

  (0, _createClass2.default)(Timer, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      clearInterval(this.interval);

      if (this.props.startTime) {
        this.interval = setInterval(this.forceUpdate.bind(this), 1000);
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      clearInterval(this.interval);
    }
  }, {
    key: "render",
    value: function render() {
      if (!this.props.startTime) {
        return false;
      }

      var elapsed = (0, _now.default)() - this.props.startTime;
      var timeFormat = 'mm:ss';

      if (elapsed > 1000 * 3600) {
        timeFormat = 'hh:mm:ss';
      }

      return _react.default.createElement("div", {
        className: (0, _classnames.default)('ciscospark-timer')
      }, _moment.default.utc(elapsed).format(timeFormat));
    }
  }]);
  return Timer;
}(_react.Component);

Timer = _wrapComponent("Timer")(Timer);
Timer.propTypes = propTypes;
var _default2 = Timer;
exports.default = _default2;